<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins';
import VueSlickCarousel from 'vue-slick-carousel';

interface Cards {
  title: string;
  description: string;
  monthlyPrice: string;
  priceText: string;
  button: {
    text: string;
    config: {
      href: string;
      dataGaName: string;
      dataGaLocation: string;
    };
  };
}

export default Vue.extend({
  components: {
    VueSlickCarousel,
  },
  mixins: [IsMobileMixin],
  props: {
    title: {
      type: String,
      required: true,
    },
    cards: {
      type: Array<Cards>,
      required: true,
    },
  },
  data() {
    return {
      activeTypeIndex: 0,
      activeCarouselIndex: 1,
    };
  },
  methods: {
    handleCarouselChange(index: number): void {
      this.activeCarouselIndex = index;
    },
    carouselGoTo(index: number): void {
      const carouselRef = this.$refs.carousel as any;
      this.activeCarouselIndex = index;
      if (carouselRef.goTo) {
        carouselRef.goTo(index);
      }
    },
    onChange(index, id) {
      this.activeTypeIndex = index;
      this.$emit('active-toggle-id', id);
    },
  },
});
</script>

<template>
  <SlpContainer class="slp-my-96">
    <SlpRow class="center">
      <div class="title" v-html="$md.render(title)" />
    </SlpRow>
    <div v-if="isMobile" class="carousel-controls">
      <button
        v-for="(card, id) in cards"
        :key="card.title"
        :class="{ active: activeCarouselIndex === id }"
        @click="carouselGoTo(id)"
      >
        <SlpTypography variant="body1-bold"> {{ card.title }} </SlpTypography>
      </button>
    </div>
    <component
      :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
      ref="carousel"
      center-mode
      :center-padding="`${width / 30}%`"
      :infinite="false"
      :dots="false"
      class="no-wrap"
      :initial-slide="1"
      @afterChange="handleCarouselChange"
    >
      <SlpColumn v-for="(card, id) in cards" :key="id">
        <div class="card__top" :class="`card__top--${id}`">
          <SlpTypography variant="heading3-bold" tag="h2">
            {{ card.title }}</SlpTypography
          >
          <SlpTypography variant="body2-bold" tag="h3">
            {{ card.description }}
          </SlpTypography>
        </div>
        <div class="card__bottom">
          <div
            v-if="card.monthlyPrice || card.monthlyPrice === 0"
            class="price"
          >
            <SlpTypography variant="heading5">$</SlpTypography>
            <SlpTypography variant="heading1-bold">
              {{ card.monthlyPrice }}</SlpTypography
            >
          </div>
          <SlpTypography variant="body2"> {{ card.priceText }}</SlpTypography>
          <SlpButton
            variant="secondary"
            class="card__button"
            :href="card.button.config.href"
            :data-ga-location="card.button.config.dataGaLocation"
            :data-ga-name="card.button.config.dataGaName"
            >{{ card.button.text }}</SlpButton
          >
        </div>
      </SlpColumn>
    </component>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.title {
  font-size: 40px;
  font-weight: 600;
  padding-bottom: 48px;
  letter-spacing: -1px;

  @media (max-width: $breakpoint-sm) {
    font-size: 32px;
    line-height: 40px;
    letter-spacing: -1.2px;
  }
}

.center {
  justify-content: center;
}

.no-wrap {
  flex-wrap: nowrap;
  gap: $spacing-16;

  @media (max-width: $breakpoint-md) {
    flex-direction: column;
  }
}

.price {
  display: flex;
}

.card__top {
  border-radius: $spacing-8 $spacing-8 0 0;
  border: 1px solid $color-primary-100;
  border-bottom: 0;
  padding: $spacing-32 $spacing-24;
  background: #f2f1f5;
  min-height: $spacing-160;
}

.card__top--1 {
  background: #eee7fd;
}

.card__top--2 {
  background: linear-gradient(to top right, #eae7f9 10%, transparent 30%),
    linear-gradient(to top left, #f9e7ea 10%, transparent 30%),
    linear-gradient(to top, rgba(234, 231, 249, 0.9), transparent 40%),
    radial-gradient(circle at top left, #fde8e8 -15%, transparent 20%), #ffffff;
}

.card__bottom {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  border-radius: 0 0 $spacing-8 $spacing-8;
  border: 1px solid $color-primary-100;
  border-top: 0;
  padding: $spacing-48 $spacing-24 $spacing-32;
  min-height: 245px;
}

.card__button {
  width: 100%;
  margin-top: $spacing-24;
  justify-content: center;
  border: 1px solid $color-primary-200;

  &:hover {
    border: 1px solid $color-primary-200;
  }
}

.carousel-controls {
  display: flex;
  width: 100%;
  justify-content: space-around;
  height: 42px;
  margin-bottom: $spacing-16;
  button {
    border: none;
    width: 100%;
    border-bottom: 1px solid transparent;
    opacity: 0.2;
    color: $color-primary-200;
    &.active {
      border-bottom: 1px solid #171321;
      opacity: 1;
    }
  }
}

.slp-col-md {
  padding-left: $spacing-8;
  padding-right: $spacing-8;
}
</style>
